<template>
  <form @submit.prevent="tryLogin" novalidate>
    <heading-een :heading="'Inloggen'" class="h1-center"></heading-een>
    <FormField id="email"
               v-model="email"
               type="email"
               :required="true"
               label="E-mail"
               :error="emailError"></FormField>
    <FormField id="password"
               v-model="password"
               type="password"
               :required="true"
               label="Wachtwoord"
               :error="passwordError"></FormField>

    <p>
      <router-link :to="{name: 'Register'}">Heeft u geen acount?</router-link>
    </p>

    <div class="btn">
      <button type="submit">Aanmelden</button>
    </div>
    <Error v-if="error" :value="error"></Error>
    <div class="loading" v-show="loading" role="alert">
      <div class="loading-animate"></div>
    </div>
  </form>
</template>

<script>
import { mapActions } from 'vuex/dist/vuex';
import FormField from '../molecules/FormField.vue';
import Error from '../atoms/Error.vue';
import HeadingEen from '../atoms/HeadingEen.vue';

const emailRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export default {
  name: 'LoginForm',
  components: {
    HeadingEen,
    Error,
    FormField,
  },
  data() {
    return {
      email: null,
      password: null,
      error: null,
      loading: false,
      submitted: false,
    };
  },
  computed: {
    emailError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.email) {
        return 'E-mail is een verplicht veld en werd niet ingevuld.';
      }
      if (!emailRegex.test(this.email)) {
        return 'Het opgegeven e-mailadres voldoet niet aan het patroon naam@voorbeeld.be';
      }
      return null;
    },
    passwordError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.password) {
        return 'Wachtwoord is een verplicht veld en werd niet ingevuld.';
      }
      return null;
    },
    hasErrors() {
      return this.emailError || this.passwordError;
    },
  },
  methods: {
    ...mapActions('auth', ['logIn']),
    async tryLogin() {
      this.submitted = true;
      if (this.hasErrors) {
        return;
      }
      this.loading = true;
      // store.user = this.email;
      // setTimeout(() => this.$router.push({ name: 'Home' }), 2000);
      try {
        await this.logIn({
          email: this.email,
          password: this.password,
        });
      } catch (e) {
        if (e.response.status === 422) {
          this.error = 'E-mail of wachtwoord is niet correct.';
          return;
        }
        this.error = 'Er is een onverwachte fout opgetreden.';
      } finally {
        this.loading = false;
        // await this.$router.go();
        await this.$router.push(this.$route.query.redirect || '/trajecten');
      }
    },
  },
};
</script>

<style scoped lang="scss">
form {
  width: 50%;
  margin: 0 auto;

  .h1-center{
    text-align: center;
    padding-top: 6.5em;
  }

  .btn{
    text-align: center;
    margin: 1em 0;
  }

  button{
    font-family: 'Roboto', sans-serif;
    padding: 15px 0;
    background-color: $my-orange;
    border-radius: 11px;
    border: none;
    width: 170px;
    height: 50px;
    text-align: center;
    color: #f8f8f8;
    font-size: 1.1em;
    /*font-size: 1.8em;*/
  }
  button:hover{
    background-color: $my-yellow;
    transition: .3s;
  }
  a{
    font-size: 1em;
    font-family: 'Roboto', sans-serif;
    color: $my-orange;
  }
  a:hover{
    color: $my-yellow;
    transition: .3s;
  }
}
.loading-animate {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid $my-blue;
  border-bottom: 8px solid $my-blue;
  width: 60px;
  height: 60px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  z-index: 6;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

@-webkit-keyframes spin {
  0% { -webkit-transform: rotate(0deg); }
  100% { -webkit-transform: rotate(360deg); }
}

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}
@media (max-width: 952px){
  form {
    width: 90%;
  }
}
</style>
